package com.framsticks.framclipse;

import org.eclipse.xtext.common.services.DefaultTerminalConverters;
import org.eclipse.xtext.conversion.IValueConverter;
import org.eclipse.xtext.conversion.ValueConverter;
import org.eclipse.xtext.conversion.ValueConverterException;
import org.eclipse.xtext.conversion.impl.AbstractToStringConverter;
import org.eclipse.xtext.nodemodel.INode;

public class FramScriptValueConverterService extends DefaultTerminalConverters {

	@ValueConverter(rule = "HEADER_VALUE")
	public IValueConverter<String> HEADER_VALUE() {

		return new AbstractToStringConverter<String>() {

			@Override
			protected String internalToValue(String s, INode node)
					throws ValueConverterException {
				String r = s;
				if (s.startsWith("~")) {
					r = s.substring(1, s.lastIndexOf('~'));
				}
				return r.trim().replaceAll("\\~", "~");
			}

		};
	}

	@ValueConverter(rule = "ML_STRING")
	public IValueConverter<String> ML_STRING() {

		return new AbstractToStringConverter<String>() {

			@Override
			protected String internalToValue(String s, INode node)
					throws ValueConverterException {
				return s.substring(3, s.length()-3);
			}

		};
	}
}
